pipeline {
    agent any
    stages {
        stage("Build") {
            agent {
                docker {
                    image 'maven:3'
                    args '-u root -v $HOME/.m2:/root/.m2'
                    reuseNode true
                }
            }
            steps {
                sh "mvn clean package -DskipTests"
                archiveArtifacts artifacts: 'target/*.jar', followSymlinks: false
            }
        }
        stage("Unit Tests") {
            agent {
                docker {
                    image 'maven:3'
                    args '-u root -v $HOME/.m2:/root/.m2'
                    reuseNode true
                }
            }
            steps {
                sh "mvn surefire:test"
                junit allowEmptyResults: true, stdioRetention: '', testResults: 'target/surefire-reports/*.xml'
            }
        }
        stage("SonarQube Analysis") {
            agent {
                docker {
                    image 'sonarsource/sonar-scanner-cli'
                    args '--network=host'
                    reuseNode true
                }
            }
            steps {
                withSonarQubeEnv('sonarqube@localhost') {
                    sh 'sonar-scanner'
                }
                waitForQualityGate abortPipeline: true
            }
        }
        stage("Nexus Publishing (jar)") {
            steps {
                nexusPublisher nexusInstanceId: 'nexus@local', nexusRepositoryId: 'maven-releases', packages: [[$class: 'MavenPackage', mavenAssetList: [[classifier: '', extension: '', filePath: 'target/hello-world-java-spring-0.0.1.jar']], mavenCoordinate: [artifactId: 'hello-world-java-spring', groupId: 'fr.formation', packaging: 'jar', version: '0.0.1']]]
            }
        }
    }
}